package com.lwby.marketing.controller;

import cn.hutool.crypto.SecureUtil;
import org.apache.commons.lang3.StringUtils;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

public class ServiceHelper {
    public String emptyIsNull(String params){
        return StringUtils.defaultIfEmpty(params,null);
    }

    public String encode(String params){
        try {
            return URLEncoder.encode(params,"utf-8");
        } catch (UnsupportedEncodingException e) {
            return null;
        }
    }

    public Integer parseInt(String params){
        try {
            return Integer.valueOf(params);
        }catch (Exception e){
            return null;
        }
    }

    public String assembleKey(String deviceId, ClickbackService.DeviceType type) {
        switch (type) {
            case IMEI:
            case OAID:
            case IDFA:
                return deviceId;
            case IP_UA:
            case IP_MODEL:
            case IP:
                return SecureUtil.md5(deviceId);
        }
        return null;
    }

    public String assembleKey(String deviceId, ClickbackService.DeviceVideoType type) {
        switch (type) {
            case OAID:
            case IDFA:
                return deviceId;
            case IP_UA:
            case IP_MODEL:
                return SecureUtil.md5(deviceId);
        }
        return null;
    }
}
